import { PreparedFlowieExecution } from '../prepared.types';
export interface RunnableDeclaration {
    readonly isAsync: boolean;
    readonly mainFlow: MainFlow;
    readonly subFlows: readonly SubFlow[];
}
export default function convertFlowDeclarationToRunnableDeclaration(preparedFlowieExecution: PreparedFlowieExecution, isAsyncFunction: CheckFunction, isGeneratorFunction: CheckFunction): RunnableDeclaration;
interface MainFlow {
    readonly functionsFromContainers: readonly string[];
    readonly steps: readonly Step[];
}
interface SubFlow {
    readonly isAsync: boolean;
    readonly functionsFromContainers: readonly string[];
    readonly hash: string;
    readonly steps: readonly Step[];
}
export declare type Step = PipeStep | SplitStep | FlowStep | GeneratorStep | FinishGeneratorsStep;
declare type PipeStep = {
    readonly pipe: string;
    readonly isAsync: boolean;
} | FlowStep;
interface SplitStep {
    readonly split: readonly (string | FlowStep)[];
    readonly isAsync: boolean;
}
interface GeneratorStep {
    readonly generator: string;
    readonly isAsync: boolean;
}
interface FinishGeneratorsStep {
    readonly finishGeneratorsCount: number;
}
interface FlowStep {
    readonly isAsync: boolean;
    readonly flow: string;
}
interface CheckFunction {
    (functionName: string): boolean;
}
export {};
