import { FlowieContainer } from '../container/createFlowieContainer';
import { FlowResult, CreateFlowieResult } from '../runtime/flowieResult';
import Reporter from '../reporter/reporter.types';
import { PreparedFlowieExecution } from '../prepared.types';
export default function generateFunctionFromFlowDeclaration<Argument, Result, Context>(preparedFlowieExecution: PreparedFlowieExecution, flowieContainer: FlowieContainer): FlowFunctionGeneration<Argument, Result, Context>;
export interface FlowFunctionGeneration<Argument, Result, Context> {
    readonly generatedFlowFunction: GeneratedFlowFunction<Argument, Result>;
    readonly generatedFlowFunctionWithContext: GeneratedFlowFunctionForContext<Argument, Result, Context>;
}
export interface GeneratedFlowFunction<Argument, Result> {
    (separateReportListFromResult: Function): (executionArguments: ExecutionArguments<Argument, Result>) => FlowResult<Result> | Promise<FlowResult<Result>>;
}
export interface GeneratedFlowFunctionForContext<Argument, Result, Context> {
    (separateReportListFromResult: Function): (executionArguments: ExecutionArgumentsForContext<Argument, Result, Context>) => FlowResult<Result> | Promise<FlowResult<Result>>;
}
interface ExecutionArguments<Argument, Result> {
    readonly flowieContainer: FlowieContainer;
    readonly argument: Argument;
    readonly flowieResult: CreateFlowieResult;
    readonly reporter: Reporter<Argument, Result, any>;
}
interface ExecutionArgumentsForContext<Argument, Result, Context> extends ExecutionArguments<Argument, Result> {
    readonly context: Context;
}
export {};
