import { FlowFunctionDetailsWithItem, FlowFunction } from '../runtime.types';
export default function createFlowieContainer(): FlowieContainer;
export declare function isFlowieContainer(possibleFlowieContainer: FlowieContainer): boolean;
export interface FlowieContainer {
    readonly getFunctionDetails: (functionToFind: Function) => FlowFunctionDetailsWithItem;
    readonly latestDetailsAdded: readonly FlowFunctionDetailsWithItem[];
    readonly allFunctionsNames: ReadonlySet<string>;
    readonly functionsContainer: FunctionsContainer;
    readonly register: (...possibleFunctionRegister: readonly PossibleFunctionRegister[]) => FlowieContainer;
    readonly merge: (...containersOrFunctions: readonly (FlowieContainer | FlowFunction)[]) => FlowieContainer;
    readonly isAsyncFunction: (functionName: string) => boolean;
    readonly isGeneratorFunction: (functionName: string) => boolean;
}
declare type PossibleFunctionRegister = FlowFunction | readonly [string, FlowFunction];
declare type FunctionsContainer = Record<string, FlowFunctionDetailsWithItem>;
export {};
