import { FlowFunctionDetails } from '../runtime.types';
import { PreparedFlowieExecution } from '../prepared.types';
export default function createFlowDeclarationManager<Argument, Result>(flowDeclarationOrFunctionList: readonly DeclarationManagerOrFunctionDetails<Argument, Result>[], preparedFlowieExecution?: PreparedFlowieExecution): PreparedFlowieManager;
export interface PreparedFlowieManager extends PreparedFlowieExecution {
    readonly pipe: PipeDeclaration;
    readonly split: (declarationManagerOrFunctionDetailsList: readonly (PreparedFlowieManager | FlowFunctionDetails)[]) => PreparedFlowieManager;
}
interface PipeDeclaration {
    (flowFunctionDetails: FlowFunctionDetails): PreparedFlowieManager;
    (preparedFlowieExecution: PreparedFlowieExecution): PreparedFlowieManager;
    (flowieExecutionDeclarationOrDetail: FlowFunctionDetails | PreparedFlowieExecution): PreparedFlowieManager;
    (nextFlowieExecuteDeclaration: PreparedFlowieManager): PreparedFlowieManager;
}
export declare function isFlowieExecutionDeclaration(preparedFlowieExecutionCandidate: PreparedFlowieExecution): boolean;
declare type DeclarationManagerOrFunctionDetails<Argument, Result> = PreparedFlowieManager | FlowFunctionDetails<Argument, Result>;
export {};
