import { FunctionReport, GeneratorReporter, GeneratorReport, HRTime, FlowFunctionsResultList } from './reporter.types';
export declare function reportFunctionCall<Argument, Result>(functionToCall: (argument: Argument) => Result, functionNameToReport: string, argument: Argument): readonly [FunctionReport, Result];
export declare function reportAsyncFunctionCall<Argument, Result>(functionToCall: (argument: Argument) => Promise<Result>, functionNameToReport: string, argument: Argument): Promise<readonly [FunctionReport, Result]>;
export declare function reportFunctionCallContext<Argument, Result, Context>(functionToCall: (argument: Argument, context?: Context) => Result, functionNameToReport: string, argument: Argument, context?: Context): readonly [FunctionReport, Result];
export declare function reportAsyncFunctionCallContext<Argument, Result, Context>(functionToCall: (argument: Argument, context?: Context) => Promise<Result>, functionNameToReport: string, argument: Argument, context?: Context): Promise<readonly [FunctionReport, Result]>;
export declare function startGeneratorReport(functionName: string): GeneratorReporter;
export declare function calculateHRTimeDifference(previousHRTime: HRTime): number;
export declare function compactFunctionReport(functionsReportList: readonly (FunctionReport | GeneratorReport)[]): FlowFunctionsResultList;
