"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = __importDefault(require("debug"));
const reporter_1 = require("../reporter/reporter");
const debug = debug_1.default('flowie:runtime:result');
const flowieResult = {
    success(lastResult, startHRTime, functionsReportList) {
        const executionTime = reporter_1.calculateHRTimeDifference(startHRTime);
        const initialHRTime = process.hrtime();
        const functions = reporter_1.compactFunctionReport(functionsReportList);
        const reportCostTime = reporter_1.calculateHRTimeDifference(initialHRTime);
        debug('Functions report compacted in %o', reportCostTime);
        return {
            success: true,
            lastResult,
            executionTime,
            functions
        };
    }
};
exports.default = flowieResult;
//# sourceMappingURL=flowieResult.js.map