"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const flowieSignature = Symbol('flowieSignature');
function signAsFlowieFunction(executeFlowFunction, flowieContainer, preparedFlowieManager) {
    return Object.freeze(
    // eslint-disable-next-line functional/immutable-data
    Object.assign(executeFlowFunction, {
        [flowieSignature]: {
            flowieContainer,
            preparedFlowieManager: preparedFlowieManager
        }
    }));
}
exports.signAsFlowieFunction = signAsFlowieFunction;
function isSignedAsFlowieFunction(flowFunction) {
    return Boolean(flowFunction) && flowieSignature in flowFunction;
}
exports.isSignedAsFlowieFunction = isSignedAsFlowieFunction;
function getFlowieContainer(flowFunction) {
    return flowFunction[flowieSignature].flowieContainer;
}
exports.getFlowieContainer = getFlowieContainer;
function getFlowieDeclarationManager(flowFunction) {
    return flowFunction[flowieSignature].preparedFlowieManager;
}
exports.getFlowieDeclarationManager = getFlowieDeclarationManager;
//# sourceMappingURL=flowieSignature.js.map